package loptice;

import javafx.animation.AnimationTimer;
import javafx.application.Application;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.input.KeyEvent;
import javafx.scene.input.MouseEvent;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;
import javafx.stage.Stage;

public class Lab01Loptice extends Application 
{
    private final Loptica[] loptice = new Loptica[15];
    private final Color[] boje = { Color.YELLOW, Color.WHITE, Color.GRAY, 
                             Color.RED, Color.ORANGE, Color.GREEN, Color.BLUE };
    private final Rectangle granica = new Rectangle(0, 0, 800, 600);
    private double g = 9.81;
    private final MyTimer timer = new MyTimer();
    private int mouseX, mouseY;
    
    private class Timer extends AnimationTimer{

        @Override
        public void handle(long now) {
            throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
        }
    }
    
    private class MyTimer extends AnimationTimer
    {
        private long prethodni = 0;
        @Override
        public void handle(long sada) // izrazeno u ns
        {
            if(prethodni == 0)
                prethodni = sada;
            float proteklo = (sada-prethodni)/1e9f; // pretvoreno u s
            for(Loptica l : loptice)
                l.pomeri(proteklo, g, granica);
            prethodni = sada;
        }        
    }
    
    @Override
    public void start(Stage primaryStage) 
    {        
        Group root = new Group();
        
        for(int i = 0; i < loptice.length; i++)
        {
            Vektor pozicija = new Vektor( 2*granica.getWidth()/3 - granica.getWidth()/3*Math.random(),
                                          2*granica.getHeight()/3 - granica.getHeight()/3*Math.random() );
            Vektor brzina = new Vektor( Math.random()*240-120, Math.random()*80-40 );

            int colorIndex1 = (int)(Math.random()*boje.length);
            int colorIndex2 = (int)(Math.random()*boje.length);

            loptice[i] = new Loptica(pozicija, brzina, (float)(Math.random()*40+10), boje[colorIndex1], boje[colorIndex2] );
        }        

        granica.setStroke(Color.RED);
        granica.setFill(null);
        
        root.getChildren().add(granica);
        root.getChildren().addAll(loptice);
                
        Scene scene = new Scene(root, granica.getWidth(), granica.getHeight());
        
        scene.setOnMousePressed( e -> onMousePressed(e) );
        scene.setOnMouseReleased(this::onMouseReleased);
        scene.setOnKeyPressed(e -> onKeyPressed(e));
        
        primaryStage.setTitle("Loptice");
        primaryStage.setScene(scene);
        primaryStage.show();
        
        timer.start();
    }

    private void onMousePressed(MouseEvent e)
    {
        mouseX = (int)e.getSceneX();
        mouseY = (int)e.getSceneY();
    }
    
    private void onMouseReleased(MouseEvent e)
    {
        int x1 = (int)Math.min(mouseX, e.getSceneX());
        int y1 = (int)Math.min(mouseY, e.getSceneY());
        int x2 = (int)Math.max(mouseX, e.getSceneX());
        int y2 = (int)Math.max(mouseY, e.getSceneY());
        
        granica.setX(x1); granica.setY(y1);
        granica.setWidth(x2-x1); granica.setHeight(y2-y1);
    }

    private void onKeyPressed(KeyEvent e)
    {
        switch( e.getCode() )
        {
            case UP:
                g += 1;
                break;
                
            case DOWN:
                if( g>1) g -= 1;
                break;
        }
    }
    
    public static void main(String[] args) 
    {
        launch(args);
    }    
}
