package objects;


import javafx.geometry.Point2D;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import models.GameModel;

public class Ball extends MovingGameObject {
	
	//private GameModel model = GameModel.getInstance();
	private float ballSpeedX = 8;
	private float ballSpeedY = ballSpeedX * 1.4f;
	
	private static final double BALL_DIAMETER = ( float ) ( GameModel.getInstance ( ).getScreenSize ( ).width * 0.025 );
	
	{
		Circle ball = new Circle ( BALL_DIAMETER );
		ball.setFill ( Color.RED );
		this.getChildren ( ).addAll ( ball );
	}
	
	// initialize speed
	{
		super.speedX = ballSpeedX;
		super.speedY = ballSpeedY;
	}
	
	
	public Ball ( Point2D position ) {
		super ( position );
	}
	
	@Override
	public void updatePosition ( ) {
		handleCollisions ( );
		position = new Point2D ( position.getX ( ) + speedX, position.getY ( ) + speedY );
		setTranslateX ( getTranslateX ( ) + speedX );
		setTranslateY ( getTranslateY ( ) + speedY );
		
		if ( speedY < 0 ) {
			speedY += 0.17;
		} else {
			speedY = ballSpeedY;
		}
	}
	
	@Override
	protected void handleCollisions ( ) {
		handleBorderCollisions ( );
		handlePlayerCollisions ( );
		handleBulletCollisions ( );
	}
	
	private void handleBulletCollisions ( ) {
		if ( GameModel.getInstance ( ).getWeapon ( ) == null ) {
			return;
		}
		if ( this.getBoundsInParent ( ) .intersects ( GameModel.getInstance ( ).getWeapon ( ).getBoundsInParent ( ) ) ) {
			GameModel.getInstance ( ).getRoot ( ).getChildren ( ).remove ( this );
			GameModel.getInstance ( ).setGameWon ( true );
		}
	}
	
	private void handlePlayerCollisions ( ) {
		if ( this.getBoundsInParent ( ).intersects ( GameModel.getInstance ( ).getPlayer ( ).getBoundsInParent ( ) ) ) {
			GameModel.getInstance ( ).setGameLost ( true );
		}
	}
	
	private void handleBorderCollisions ( ) {
		if ( position.getX ( ) - BALL_DIAMETER < 0 || position.getX ( ) > GameModel.getInstance ( ).getSceneWidth ( ) - BALL_DIAMETER ) {
			speedX = -speedX;
		}
		
		if ( position.getY ( ) - BALL_DIAMETER < 0 || position.getY ( ) > GameModel.getInstance ( ).getSceneHeight ( ) - BALL_DIAMETER ) {
			speedY = -speedY;
			//speedY = Math.signum(speedY) * GameModel.getInstance().ballSpeedY;
		}
	}
}
